@REM Copyright by The HDF Group.
@REM Copyright by the Board of Trustees of the University of Illinois.
@REM All rights reserved.
@REM
@REM This file is part of HDF5.  The full HDF5 copyright notice, including
@REM terms governing use, modification, and redistribution, is contained in
@REM the files COPYING and Copyright.html.  COPYING can be found at the root
@REM of the source code distribution tree; Copyright.html can be found at the
@REM root level of an installed copy of the electronic HDF5 document set and
@REM is linked from the top-level documents page.  It can also be found at
@REM http://hdfgroup.org/HDF5/doc/Copyright.html.  If you do not have
@REM access to either file, you may request a copy from help@hdfgroup.org.

@ECHO OFF
REM This batch file is used to test HDF5 Fortran examples.
REM Created: 08/20/2009

if %1.==. GOTO WRONG
if "%1"=="/?" GOTO HELP
if %1==release GOTO RELEASE
if %1==debug GOTO DEBUG
GOTO WRONG

:RELEASE
type nul > %1.txt
cd release
GOTO RUNTESTS

:DEBUG
type nul > %1.txt
cd debug
GOTO RUNTESTS

:RUNTESTS
fileexampletest >> ..\%1.txt
groupexampletest >> ..\%1.txt
dsetexampletest >> ..\%1.txt
attrexampletest >> ..\%1.txt
rwdsetexampletest >> ..\%1.txt
grpsexampletest >> ..\%1.txt
grpdsetexampletest >> ..\%1.txt
mountexampletest >> ..\%1.txt
hyperslabtest >> ..\%1.txt
compoundtest >> ..\%1.txt
grpittest >> ..\%1.txt
refobjexampletest >> ..\%1.txt
refregexampletest >> ..\%1.txt
selecteletest >> ..\%1.txt
cd ..
more /e +3 testf90examples_exp_output.txt  > output.txt
fc %1.txt output.txt >temp.txt
if %ERRORLEVEL%==0 (
   echo All HDF5 Fortran examples tests passed.
) else (
   echo HDF5 Fortran examples tests failed.
   echo.
   more temp.txt
)
del output.txt
del temp.txt
GOTO END

:WRONG
echo The syntax of the command is incorrect.
echo.

:HELP
echo Tests HDF5 Fortran examples.
echo.
echo testf90examples [OPTION]
echo.
echo Please use one of the following options!
echo.
echo    testf90examples release        test HDF5 Fortran examples -- release version
echo    testf90examples debug          test HDF5 Fortran examples -- debug version
echo    testf90examples /?             Help information
echo.

:END
