@REM Copyright by The HDF Group.
@REM Copyright by the Board of Trustees of the University of Illinois.
@REM All rights reserved.
@REM
@REM This file is part of HDF5.  The full HDF5 copyright notice, including
@REM terms governing use, modification, and redistribution, is contained in
@REM the files COPYING and Copyright.html.  COPYING can be found at the root
@REM of the source code distribution tree; Copyright.html can be found at the
@REM root level of an installed copy of the electronic HDF5 document set and
@REM is linked from the top-level documents page.  It can also be found at
@REM http://hdfgroup.org/HDF5/doc/Copyright.html.  If you do not have
@REM access to either file, you may request a copy from help@hdfgroup.org.

@ECHO OFF
REM This batch file is used to build HDF5 Fortran examples.
REM Created: 08/20/2009

if %1.==. GOTO WRONG
if "%1"=="/?" GOTO HELP
if "%1"=="release" GOTO RELEASE
if "%1"=="debug" GOTO DEBUG

:DEBUG
REM Setup variable for library files
set LD=d
GOTO BUILD

:RELEASE
REM Setup variable for library files
set LD=
GOTO BUILD

:BUILD
echo.
LF95 attrexample.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 compound.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 dsetexample.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 fileexample.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 groupexample.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 grpdsetexample.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 grpit.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 grpsexample.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 hyperslab.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 mountexample.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 refobjexample.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 refregexample.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 rwdsetexample.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
LF95 selectele.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib"
GOTO END

:WRONG
echo The syntax of the command is incorrect.
echo Use Build_f90examples /? for usage informtaion
echo.
GOTO END

:HELP
echo Tests HDF5 Fortran examples.
echo.
echo Build_f90examples [OPTION]
echo.
echo Please use one of the following options!
echo.
echo Build_f90examples release     Build HDF5 Fortran examples -- release version
echo Build_f90examples debug       Build HDF5 Fortran examples -- debug version
echo Build_f90examples /?          Help information
echo.
GOTO END

:END
