!****h* fortran/src/H5fortran_detect.f90
!
! NAME
!  H5fortran_detect
! 
! FUNCTION
!  This stand alone program is used at build time to generate the header file
!  H5fort_type_defines.h. The source code itself was automatically generated by
!  the program H5test_kind.f90
!
! NOTES
!  This source code does not make use of the Fortran intrinsic function SIZEOF because
!  the availability of the intrinsic function was determined to be not available at
!  configure time
!
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
!   Copyright by The HDF Group.                                               *
!   Copyright by the Board of Trustees of the University of Illinois.         *
!   All rights reserved.                                                      *
!                                                                             *
!   This file is part of HDF5.  The full HDF5 copyright notice, including     *
!   terms governing use, modification, and redistribution, is contained in    *
!   the files COPYING and Copyright.html.  COPYING can be found at the root   *
!   of the source code distribution tree; Copyright.html can be found at the  *
!   root level of an installed copy of the electronic HDF5 document set and   *
!   is linked from the top-level documents page.  It can also be found at     *
!   http://hdfgroup.org/HDF5/doc/Copyright.html.  If you do not have          *
!   access to either file, you may request a copy from help@hdfgroup.org.     *
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
!
! AUTHOR
!  H5test_kind.f90
!
!*****

 PROGRAM int_kind
 WRITE(*,*) " /*generating header file*/ "
 CALL i00()
 CALL r00()
 CALL d00()
 CALL i01()
 CALL i02()
 CALL i04()
 CALL i08()
 CALL r04()
 CALL r08()
 CALL r16()
 END PROGRAM int_kind
 SUBROUTINE i00()
    IMPLICIT NONE
    INTEGER :: a = 0
    INTEGER :: a_size
    a_size = BIT_SIZE(a)
    IF (a_size .EQ. 8) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_NATIVE_1" 
    endif
    IF (a_size .EQ. 16) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_NATIVE_2" 
    endif
    IF (a_size .EQ. 32) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_NATIVE_4" 
    ENDIF
    IF (a_size .EQ. 64) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_NATIVE_8" 
    ENDIF
    IF (a_size .EQ. 128) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_NATIVE_16" 
    ENDIF
    RETURN
 END SUBROUTINE
 SUBROUTINE r00()
    IMPLICIT NONE
    REAL :: b(32)
    INTEGER :: a(1)
    INTEGER :: a_size
    INTEGER :: real_size
    a_size = BIT_SIZE(a(1)) ! Size in bits for integer
    real_size = (SIZE(TRANSFER(b,a))*a_size)/SIZE(b)
    IF (real_size .EQ. 32) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_REAL_NATIVE_4" 
    ENDIF
    IF (real_size .EQ. 64) THEN
        write(*,*) "#define H5_FORTRAN_HAS_REAL_NATIVE_8" 
    endif
    IF (real_size .EQ. 128) THEN
        write(*,*) "#define H5_FORTRAN_HAS_REAL_NATIVE_16" 
    ENDIF
    RETURN
 END SUBROUTINE
 SUBROUTINE d00()
    IMPLICIT NONE
    DOUBLE PRECISION :: b=0
    INTEGER :: a(8)=0
    INTEGER :: a_size
    INTEGER :: b_size
    a_size = BIT_SIZE(a(1))
    b_size = SIZE(transfer(b,a))*a_size
    IF (b_size .EQ. 64) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_DOUBLE_NATIVE_8" 
    ENDIF
    IF (b_size .EQ. 128) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_DOUBLE_NATIVE_16" 
    ENDIF
    RETURN
 END SUBROUTINE
 SUBROUTINE i01()
    IMPLICIT NONE
    INTEGER( 1 ) :: a = 0
    INTEGER :: a_size
    a_size = BIT_SIZE(a)
    IF (a_size .EQ. 8) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_1" 
    ENDIF
    IF (a_size .EQ. 16) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_2" 
    ENDIF
    IF (a_size .EQ. 32) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_4" 
    ENDIF
    IF (a_size .EQ. 64) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_8" 
    ENDIF
    IF (a_size .EQ. 128) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_16" 
    ENDIF
    RETURN
    END SUBROUTINE
 SUBROUTINE i02()
    IMPLICIT NONE
    INTEGER( 2 ) :: a = 0
    INTEGER :: a_size
    a_size = BIT_SIZE(a)
    IF (a_size .EQ. 8) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_1" 
    ENDIF
    IF (a_size .EQ. 16) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_2" 
    ENDIF
    IF (a_size .EQ. 32) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_4" 
    ENDIF
    IF (a_size .EQ. 64) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_8" 
    ENDIF
    IF (a_size .EQ. 128) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_16" 
    ENDIF
    RETURN
    END SUBROUTINE
 SUBROUTINE i04()
    IMPLICIT NONE
    INTEGER( 4 ) :: a = 0
    INTEGER :: a_size
    a_size = BIT_SIZE(a)
    IF (a_size .EQ. 8) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_1" 
    ENDIF
    IF (a_size .EQ. 16) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_2" 
    ENDIF
    IF (a_size .EQ. 32) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_4" 
    ENDIF
    IF (a_size .EQ. 64) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_8" 
    ENDIF
    IF (a_size .EQ. 128) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_16" 
    ENDIF
    RETURN
    END SUBROUTINE
 SUBROUTINE i08()
    IMPLICIT NONE
    INTEGER( 8 ) :: a = 0
    INTEGER :: a_size
    a_size = BIT_SIZE(a)
    IF (a_size .EQ. 8) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_1" 
    ENDIF
    IF (a_size .EQ. 16) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_2" 
    ENDIF
    IF (a_size .EQ. 32) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_4" 
    ENDIF
    IF (a_size .EQ. 64) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_8" 
    ENDIF
    IF (a_size .EQ. 128) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_INTEGER_16" 
    ENDIF
    RETURN
    END SUBROUTINE
 SUBROUTINE r04()
    IMPLICIT NONE
    REAL(KIND= 4 ) :: b(32)
    INTEGER :: a(1)
    INTEGER :: a_size
    INTEGER :: real_size
    a_size = BIT_SIZE(a(1)) ! Size in bits for integer
    real_size = (SIZE(TRANSFER(b,a))*a_size)/SIZE(b)
    IF (real_size .EQ. 32) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_REAL_4" 
    ENDIF
    IF (real_size .EQ. 64) THEN
        write(*,*) "#define H5_FORTRAN_HAS_REAL_8" 
    endif
    IF (real_size .EQ. 128) THEN
        write(*,*) "#define H5_FORTRAN_HAS_REAL_16" 
    ENDIF
    RETURN
    END SUBROUTINE
 SUBROUTINE r08()
    IMPLICIT NONE
    REAL(KIND= 8 ) :: b(32)
    INTEGER :: a(1)
    INTEGER :: a_size
    INTEGER :: real_size
    a_size = BIT_SIZE(a(1)) ! Size in bits for integer
    real_size = (SIZE(TRANSFER(b,a))*a_size)/SIZE(b)
    IF (real_size .EQ. 32) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_REAL_4" 
    ENDIF
    IF (real_size .EQ. 64) THEN
        write(*,*) "#define H5_FORTRAN_HAS_REAL_8" 
    endif
    IF (real_size .EQ. 128) THEN
        write(*,*) "#define H5_FORTRAN_HAS_REAL_16" 
    ENDIF
    RETURN
    END SUBROUTINE
 SUBROUTINE r16()
    IMPLICIT NONE
    REAL(KIND= 16 ) :: b(32)
    INTEGER :: a(1)
    INTEGER :: a_size
    INTEGER :: real_size
    a_size = BIT_SIZE(a(1)) ! Size in bits for integer
    real_size = (SIZE(TRANSFER(b,a))*a_size)/SIZE(b)
    IF (real_size .EQ. 32) THEN
        WRITE(*,*) "#define H5_FORTRAN_HAS_REAL_4" 
    ENDIF
    IF (real_size .EQ. 64) THEN
        write(*,*) "#define H5_FORTRAN_HAS_REAL_8" 
    endif
    IF (real_size .EQ. 128) THEN
        write(*,*) "#define H5_FORTRAN_HAS_REAL_16" 
    ENDIF
    RETURN
    END SUBROUTINE
