@REM Copyright by The HDF Group.
@REM Copyright by the Board of Trustees of the University of Illinois.
@REM All rights reserved.
@REM
@REM This file is part of HDF5.  The full HDF5 copyright notice, including
@REM terms governing use, modification, and redistribution, is contained in
@REM the files COPYING and Copyright.html.  COPYING can be found at the root
@REM of the source code distribution tree; Copyright.html can be found at the
@REM root level of an installed copy of the electronic HDF5 document set and
@REM is linked from the top-level documents page.  It can also be found at
@REM http://hdfgroup.org/HDF5/doc/Copyright.html.  If you do not have
@REM access to either file, you may request a copy from help@hdfgroup.org.

@ECHO OFF
REM This batch file is used to build HDF5 High Level Fortran examples.
REM Created: 08/20/2009

if %1.==. GOTO WRONG
if "%1"=="/?" GOTO HELP
if "%1"=="release" GOTO RELEASE
if "%1"=="debug" GOTO DEBUG

:DEBUG
REM Setup variable for library files
set LD=d
GOTO BUILD

:RELEASE
REM Setup variable for library files
set LD=
GOTO BUILD

:BUILD
echo.
LF95 exlite.f90 -nconcc -ml MSVC -mod "..\..\%1\include\" -i "..\..\%1\include\" -libpath "..\..\%1\dll\;..\..\%1\lib\" "hdf5_f90cstub%LD%dll.lib" "hdf5_fortran%LD%.lib" "hdf5_hl%LD%dll.lib" "hdf5_hl_f90cstub%LD%dll.lib" "hdf5_hl_fortran%LD%.lib"
GOTO END

:WRONG
echo The syntax of the command is incorrect.
echo Use Build_hl_f90examples /? for usage informtaion
echo.
GOTO END

:HELP
echo Build HDF5 High Level Fortran examples.
echo.
echo Build_hl_f90examples [OPTION]
echo.
echo Please use one of the following options!
echo.
echo Build_hl_f90examples release     Build HDF5 HL Fortran examples -- release version
echo Build_hl_f90examples debug       Build HDF5 HL Fortran examples -- debug version
echo Build_hl_f90examples /?          Help information
echo.
GOTO END

:END
