@REM Copyright by The HDF Group.
@REM Copyright by the Board of Trustees of the University of Illinois.
@REM All rights reserved.
@REM
@REM This file is part of HDF5.  The full HDF5 copyright notice, including
@REM terms governing use, modification, and redistribution, is contained in
@REM the files COPYING and Copyright.html.  COPYING can be found at the root
@REM of the source code distribution tree; Copyright.html can be found at the
@REM root level of an installed copy of the electronic HDF5 document set and
@REM is linked from the top-level documents page.  It can also be found at
@REM http://hdfgroup.org/HDF5/doc/Copyright.html.  If you do not have
@REM access to either file, you may request a copy from help@hdfgroup.org.

@ECHO OFF
REM This batch file is used to build HDF5 High Level Fortran examples using MSBuild.
REM Created: 08/20/2009

if %1.==. GOTO WRONG
if "%1"=="/?" GOTO HELP
if "%1"=="release" GOTO BUILD
if "%1"=="debug" GOTO BUILD

:BUILD
if %2.==. GOTO SOLUTION
GOTO WRONG

:SOLUTION
cd allhlf90examples
MSBuild allhlf90examples.sln /t:Rebuild /p:Configuration=%1
cd ..
GOTO END

:WRONG
echo The syntax of the command is incorrect.
echo Use MSBuild_hl_f90examples /? for usage informtaion
echo.
GOTO END

:HELP
echo Build HDF5 High Level Fortran examples.
echo.
echo MSBuild_hl_f90examples [OPTION]
echo.
echo Please use one of the following options!
echo.
echo MSBuild_hl_f90examples release     Build HDF5 HL Fortran examples -- release version
echo MSBuild_hl_f90examples debug       Build HDF5 HL Fortran examples -- debug version
echo MSBuild_hl_f90examples /?          Help information
echo.
GOTO END

:END
